#!/bin/bash




# $1 record (ex: mgh/mgh001 , challenge2014/set-p/100

recpath=$1

rec=$(basename $recpath)

dataDir=$(echo $recpath | rev | cut -d"/" -f2- | rev)
dataDir=$dataDir'/'



##write information to $1'channelsinform.txt' 
./inspectrecord $recpath $rec


channelinformfname=$rec'channelsinform.txt'

#################extract information about signals in record###########
#################from file $channelinformfname
#
#
numlines=$(wc $channelinformfname | awk '{print $1}')

numsignals=$(( numlines -1))
numsignals=$(($numsignals/2))

echo "numsignals is $numsignals"

declare -a bufferfile

readarray bufferfile < $channelinformfname

samplingfreq=$(echo $bufferfile{[0]} | awk '{print $2}')

echo "samplingfreq is $samplingfreq"
#echo ${bufferfile[0]}

numelements=$(( ${#bufferfile[@]} ))
echo "Number of rows is $numelements"

#channels we use
for i in $(seq 0 $((numsignals-1)) )
do
  signals[$i]=$(echo ${bufferfile[$((2*i+1))]} | awk '{print $1}')
  echo "${signals[$i]}"
done

#type of signal (ECG/bloodpressure) on each channel we use
for i in $(seq 0 $((numsignals-1)) )
do
  signaltype[$i]=$(echo ${bufferfile[$((2*i+1))]} | awk '{print $2}')
  echo "${signaltype[$i]}"
done

#numsamples on each channel (should be the same for all)
for i in $(seq 0 $((numsignals-1)) )
do
  numsamples[$i]=$(echo ${bufferfile[$((2*i+2))]} | awk '{print $2}')
  echo "${numsamples[$i]}"
done


##############################################################
#
#################
##number of signals to use is $numsignals
##sampling rate is $samplingfreq
##channels we use is array 'signals'
##type of signal ECG/bloodpressure is an array 'signaltype'
##numsamples each channel we use is an array 'numsamples'
###############################################################




###write signalquality information about each signal in a file######

############!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
##for bps comparedetections.sh has to be changed to compare bp detections against gqrs
## !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
for i in $(seq 0 $((numsignals-1)) )
do

echo "./computesignalpower.sh $1 ${signals[i]}"

./computesignalpower.sh $1 ${signals[i]}


if [ "${signaltype[$i]}" == "ECG" ]
then
    echo "signal type is ${signaltype[$i]} -> ./comparedetections.sh $1 ${signals[i]}"
    ./comparedetections.sh $1 ${signals[i]}
fi

if [ "${signaltype[$i]}" == "bloodpressure" ]
then
    echo "signal type is ${signaltype[$i]} -> ./runbpbeatdetector.sh $1 ${signals[i]}"
    ./runbpbeatdetector.sh $1 ${signals[i]}
fi

done

echo "signals are ${signals[*]}"

echo "./readsignals_qualityindices $recpath $rec $samplingfreq ${signals[*]} ${signaltype[*]}"
./readsignals_qualityindices $recpath $rec $samplingfreq ${signals[*]} ${signaltype[*]} 

## a txt file is produced with the final annotations->beatannotations.txt

#echo "./readsignals_qualityindices $recpath $rec $samplingfreq ${signals[*]} ${signaltype[*]}"

#produce final (binary wfdb format) annotations file
rr2ann -r $rec -T -F $samplingfreq -a qrs<beatannotations.txt