#include<gsl/gsl_matrix.h>
#include<gsl/gsl_vector.h>
#include<string>

using namespace std;


//aux functions for 1hid autoencoder

void convertrecnum2str(int recnum, char*recstr);

void recnum2fname(int recordnum, const char*basedir, char*fname);

int givenumsamples( WFDB_Siginfo *s,int sig);

int loadsignalsimple(float*signal, char*fname , char* signaltype,int*baselinept,float*gainpt, int samplingfreq);

int loadsignalsetp(float*signal, int recnum , char* signaltype,int*baselinept,float*gainpt, int samplingfreq);

int loadsignalsimple(vector<float>&signal, char*fname , int sig, int nsig,
		     int samplingfreq,
		     float begin, float end, int&firstsample, int&lastsample);

int loadannotations(char*record, char*nameannot, int workingfs, vector<int>&annotations,
		    int annotsamplingfreq, float begin, float end);//in seconds

void normalizesignal(float*signal, int numsamples);//zero mean and unit variance

void createbatchdata(const gsl_vector_float*signal, 
		     gsl_matrix_float*batchdata,
		     const int*permutation,
		     int delay,//=0 for input data, =L/2 for target data
		     int trainingstep, int batch);

void createbatchdata(const gsl_vector_float*signal, 
		     gsl_matrix_float*batchdata,
		     const int*permutation,
		     const vector<int>&beginnings,  int delay, int batch);

void fwdnetbatch(const gsl_matrix_float*inputdata,
		 const gsl_matrix_float*w1,
		 const gsl_vector_float*bias1,
		 const gsl_matrix_float*w2,
		 const gsl_vector_float*bias2,
		 gsl_matrix_float*outputdata,
		 gsl_matrix_float*hid1data);

void fwdnetinputsignal(const gsl_vector_float*inputsignal,
		       const gsl_matrix_float*w1, const gsl_vector_float*bias1,
		       const gsl_matrix_float*w2, const gsl_vector_float*bias2,
		       gsl_vector_float*outputsignal,
		       int batchsize, int inputpatchsize, int outputpatchsize,
		       int delay, int inputstep, int outputstep);




void fwdautoencoderbatch(const gsl_matrix_float*inputdata,
		 const gsl_matrix_float*w,
		 const gsl_vector_float*bias1,
		 const gsl_vector_float*bias2,
		 gsl_matrix_float*outputdata,
		 gsl_matrix_float*codedata);

void fwdautoencoderinputsignal(const gsl_vector_float*inputsignal,
		       const gsl_matrix_float*w, const gsl_vector_float*bias1,
		       const gsl_vector_float*bias2,
		       gsl_vector_float*outputsignal,
		       int batchsize);


void fwdautoencoderinputsignal(const gsl_vector_float*inputsignal,
			       const gsl_matrix_float*w,
			       const gsl_vector_float*bias1,
			       const gsl_vector_float*bias2,
			       gsl_vector_float*outputsignal,
			       int batchsize,int outputL);

void savebiasesandweightsautoencoder(const char*fname, 
				     const gsl_matrix_float *w,
				     const gsl_vector_float*biases1,
				     const gsl_vector_float*biases2);

void loadbiasesandweightsautoencoder(const char*fname, 
				     gsl_matrix_float *w,
				     gsl_vector_float*biases1,
				     gsl_vector_float*biases2);


void sum_matrix_columns( gsl_vector_float*v, const gsl_matrix_float*mat);

float givesamplerrorsigmoide(const gsl_matrix_float*inputdata,
			     const gsl_matrix_float*targetdata,
			     gsl_matrix_float*hid1data,
			     gsl_matrix_float*outputdata,
			     const gsl_matrix_float*w1,
			     const gsl_vector_float*bias1,
			     const gsl_matrix_float*w2,
			     const gsl_vector_float*bias2);


void savebiasesandweightsnnet1hid(const char*fname, 
				     const gsl_matrix_float *w1,
				     const gsl_matrix_float *w2,
				     const gsl_vector_float*biases1,
				  const gsl_vector_float*biases2);

void loadbiasesandweightsnnet1hid(const char*fname, 
				     gsl_matrix_float *w1,
				     gsl_matrix_float *w2,
				     gsl_vector_float*biases1,
				  gsl_vector_float*biases2);


void createsignalqrs(vector<int>&annotations,float*signalqrs,
		     int samplingfreq, int numsamples, int numannot);
