#include <stdio.h>
#include <stdlib.h>

#define TOLERANCE 150

typedef struct {
  int number ;
  int fs ;
  int *mem ;
} Beat_array ;

typedef struct {
  int number ;
  int *original ;
  int *parallel ;
} PBeat_array ;

typedef struct {
  int number ;
  int *mem ;
  int *beg ;
  int *end ;
} IBeat_array ;

typedef struct {
  int number ;
  int *mem ;
  float *quality ;
} QBeat_array ;

/* just the typical functions to alloc and to free memory */
Beat_array *Beat_array_init ( int nelements) ;
void Beat_array_free( Beat_array *in ) ;

Beat_array* Beat_array_from_File( char *filename ) ;

PBeat_array *PBeat_array_init ( int number ) ;
void PBeat_array_free(PBeat_array *in) ;
PBeat_array *PBeat_from_arrays(Beat_array *abeat , Beat_array *bbeat) ;


IBeat_array *IBeat_array_init(int number) ;
void IBeat_array_free(IBeat_array *in) ;
IBeat_array *IBeat_from_array(Beat_array *in , /* tipically this is a list of qrs by some detector */
			      int fs , /* the sampling frequency of the record */
			      int length ) ; /* this is the length of the interval where we are going to select beats */

IBeat_array *NIBeat_from_array(Beat_array *in , /* tipically this is a list of qrs by some detector */
			      int fs , /* the sampling frequency of the record */
			      int length ) ; /* this is the length of the interval where we are going to select beats */

int soma (int *lista , int initl , int number ) ;
QBeat_array *QBeat_array_init(int number) ;
void QBeat_array_free(QBeat_array *in) ;
QBeat_array *QBeat_from_arrays(Beat_array *a_beat , Beat_array *b_beat , int fs , int length ) ;
QBeat_array *NQBeat_from_arrays(Beat_array *a_beat , Beat_array *b_beat , int fs , int length ) ;

void timeformat( int position , int fs , char *tempo) ;
