//this function reads the record's path and vector of time strings
//and inserts the signal, at a predefined samplingfreq,
// a vector of beginnings and a set of reference beat locations
//into a long signal and a long vector of beginnings 

#include <wfdb/wfdb.h>
#include<vector>
#include<string>
#include<iostream>
#include<fstream>
#include<sstream>
#include<cassert>
using namespace std;

#include "auxfunctions.h"

/*
void givebeginnings(float timestart, float timefinish,
		   float samplingfreq, float step,//step in secs between 2 begin
		   float inputtimelength,// in secs
		    vector<int>&beginnings);//beginnings does not need to be empty



void insertrecord(char*recpath,char*nameannot,
		  const vector<float>&timeintervals,//seconds
		  float timestepbeginnings,
		  float inputtimelength, int samplingfreq, char*signaltype, 
		  vector<float>&longsignal,vector<int>&longqrsannot,
		  vector<int>&beginnings){

  //setifreq(samplingfreq);//if necessary change sampling frequency to get signal samples and annotations

  int lastsamplelongsignal=longsignal.size();
  int lastbeginnings=beginnings.size();
  int lastnumannotations=longqrsannot.size();

  float annotfs=sampfreq(recpath);

  int sig;
  //  int baseline;
  float gain;

  int nsig;
  nsig=isigopen(recpath,NULL,0);
  WFDB_Siginfo *s=new WFDB_Siginfo[nsig];
  if (isigopen(recpath, s, nsig) < nsig)
    exit(1);

  sig=findsig(signaltype);
  // baseline=s[sig].baseline;
  // gain=s[sig].gain;
  // if(gain==0)
  //   gain=WFDB_DEFGAIN;//default wfdb gain


  setifreq(samplingfreq);

  int numsamples=0, firstsample,lastsample, numnewbeginnings, base=lastsamplelongsignal;

  //start at i=1 (i=0 contains the number of intervals)
  for(int i=1;i<(int) timeintervals.size();i+=2){

    //signal--------------------------------------------------
 
    numsamples+=loadsignalsimple(longsignal, recpath, sig, nsig, samplingfreq,
				timeintervals[i], timeintervals[i+1],
				firstsample,lastsample);

    
 
    //annotations----------------------------------------------
    int numnewannotations=loadannotations(recpath, nameannot, samplingfreq,
					  longqrsannot, annotfs,
					  timeintervals[i], timeintervals[i+1]);
    //correct annotations
    for(int j=0;j<numnewannotations;++j)
      longqrsannot[lastnumannotations+j]+=base;
    

    //beginnings--------------------------------------------------------------
    givebeginnings(timeintervals[i], timeintervals[i+1],
		   samplingfreq,
		   timestepbeginnings, inputtimelength, beginnings);

    numnewbeginnings=beginnings.size()-lastbeginnings;

    //correct the value of the just inserted beginnings
    for(int j=lastbeginnings;j<(int) beginnings.size();++j)
      beginnings[j]+=base-firstsample;

    lastnumannotations+=numnewannotations;
  lastbeginnings+=numnewbeginnings; 
    base+=lastsample-firstsample+1;
  }

  //alredy done in load signal simple using "aduphys"  
  // for(int i=0;i<numsamples;++i)//convert to real physical units
  //   longsignal[lastsamplelongsignal+i]=
  //     (longsignal[lastsamplelongsignal+i]-baseline)/gain;
  

  delete[] s;

  wfdbquit();
}


//insert_the all record for test no need for beginnings
int insertrecordall(char*recpath,char*nameannot, int samplingfreq,
		     char*signaltype, 
		     vector<float>&longsignal,vector<int>&longqrsannot){

 

  float annotfs=sampfreq(recpath);

  int sig;
  int baseline;
  float gain;

  int nsig;
  nsig=isigopen(recpath,NULL,0);
  WFDB_Siginfo *s=new WFDB_Siginfo[nsig];
  if (isigopen(recpath, s, nsig) < nsig)
    exit(1);

  sig=findsig(signaltype);
  // baseline=s[sig].baseline;
  // gain=s[sig].gain;
  // if(gain==0)
  //   gain=WFDB_DEFGAIN;//default wfdb gain
  int nsamp=s[sig].nsamp;

  setifreq(samplingfreq);

  int numsamples=nsamp*samplingfreq/annotfs;
  int firstsample,lastsample;
  float timestart=0, endtime;

  endtime=numsamples/samplingfreq;

  //signal--------------------------------------------------
 


  numsamples=loadsignalsimple(longsignal, recpath, sig, nsig, samplingfreq,
			       timestart, endtime, firstsample,lastsample);

    
 
  //annotations----------------------------------------------
  loadannotations(recpath, nameannot, samplingfreq, longqrsannot, annotfs,
		  timestart, endtime);
  
  //alredy done in load signal simple using "aduphys"
  // for(int i=0;i<numsamples;++i)//convert to real physical units
  //   longsignal[i]=(longsignal[i]-baseline)/gain;
  

  delete[] s;

  wfdbquit();

  return numsamples;
}
*/


//insertrecordall no annotations are used
int insertrecordall(char*recpath, int samplingfreq,
		    int sig, vector<float>&longsignal){

 

  float annotfs=sampfreq(recpath);

  //int sig;

  int nsig;

  nsig=isigopen(recpath,NULL,0);
  WFDB_Siginfo *s=new WFDB_Siginfo[nsig];
  if (isigopen(recpath, s, nsig) < nsig)
    exit(1);

  //sig=findsig(signaltype);
  // baseline=s[sig].baseline;
  // gain=s[sig].gain;
  // if(gain==0)
  //   gain=WFDB_DEFGAIN;//default wfdb gain
  int nsamp=s[sig].nsamp;

  setifreq(samplingfreq);

  int numsamples=nsamp*samplingfreq/annotfs;

  printf("initialy were %d samples, after resampling numsamples is %d\n",
	 nsamp, numsamples);fflush(stdout);



  int firstsample,lastsample;
  float timestart=0, endtime;

  endtime=numsamples/samplingfreq;

  //signal--------------------------------------------------
 


  numsamples=loadsignalsimple(longsignal, recpath, sig, nsig, samplingfreq,
			       timestart, endtime, firstsample,lastsample);

    
  delete[] s;

  wfdbquit();

  return numsamples;
}


 


//convert string HH:MM:s  (HH int, MM int, s float  to x (float) sec
float convert_time2sec(const char*time){

  int  hrs, mins;
  float secs;
  sscanf(time,"%d:%d:%f", & hrs, &mins, &secs);
  return hrs*3600+mins*60+secs;
}





/*
int readrecordsandintervalsfromfile(char*fname, vector<string>&records,
				    vector<string>&signaltype,
				    vector<vector<float> >&intervals){

  string line,word;
  int numintervals,i;
  float time;//in seconds
  vector<float> dataonerecord;

  int numrecords=0;

  ifstream file(fname);
  if (file.is_open()){
   
    while( getline(file,line)){
       //process the line

      istringstream iss(line);

      if(iss>>word){
	records.push_back(word);
	printf("%s ",word.c_str());
      }
      else
	exit(-1);


     if(iss>>word){
	signaltype.push_back(word);
	printf("%s ",word.c_str());
      }
      else
	exit(-3);



      if(iss>>numintervals)
	dataonerecord.push_back(numintervals);
      else
	exit(-2);
    
       i=0;
       while(iss>>word){
	 i++;
	 time=convert_time2sec(word.c_str());
	 dataonerecord.push_back(time);
       }
       assert(i==2*numintervals);
       intervals.push_back(dataonerecord);
       dataonerecord.clear();
       numrecords++;
    }
  }

  else{
    printf("Can not open file %s\n",fname);
    exit(-2);
  }

  return numrecords;
}




//test this function________________________________________________________
//-------------------------------------------------------------------------

int main(int argc, char *argv[]){


  char signaltype[]="BP";

  int fs=100;

  //char basedir[]="/data/challenge2014data/set-p/";



  //read recods and intervals from file

  vector<string> records;
  vector<vector<float> > intervals;//for each record exists a vector<float>;
  //first element indicates the number of intervals and the next 2k floats are
  // the limits(start, end) of each the interval (in seconds)
 

  char fname[]="recordsintervals.txt";

  int numrecords=readrecordsandintervalsfromfile(fname, records, intervals);



  char nameannot[]="atr";

  vector<float> signal;   
  vector<int> annotations, beginnings;
 

  float timestepbeginnings=1;
  float inputtimelength=3;


  //printf("signal size is %d\n",signal.size());

  for(int i=0;i<numrecords;++i){


    insertrecord( records[i].c_str(), nameannot, intervals[i],
		  timestepbeginnings,
		  inputtimelength, fs, signaltype, 
		  signal, annotations, beginnings);

    printf("signal size is %d\n",signal.size());

  }

  printf("num beginnings is %d\n",beginnings.size());

  FILE*fid=fopen("beginnings.txt","w");
  for(int i=0;i<beginnings.size();++i)
    fprintf(fid,"%d\t",beginnings[i]);
  fclose(fid);

  fid=fopen("longsignal.txt","w");
  for(int i=0;i<signal.size();++i)
    fprintf(fid,"%f\t",signal[i]);
  fclose(fid);

  float*signalqrs=new float[signal.size()];
  createsignalqrs(annotations, signalqrs,
		  fs, signal.size(), annotations.size());

  fid=fopen("signalqrs.txt","w");
  for(int i=0;i<signal.size();++i)
    fprintf(fid,"%f\n",signalqrs[i]);
  fclose(fid);

  delete[] signalqrs;

  // for(int i=0;i<annotations.size();++i)
  //     printf("%d\t",annotations[i]);

  return 0;
}

*/

