//apply a moving average filterto signal, centered to avoid phase shifting


#include <wfdb/wfdb.h>
#include<vector>
#include<string>
#include<iostream>
#include<fstream>
#include<sstream>
#include<cassert>
using namespace std;

//#include "../bib/auxfunctions.h"



void movingaveragefilter(const float*inputsignal, float*outputsignal,
			 int filterL, int inputsignalL){
  if(inputsignalL<filterL+1){
    printf("signal length is too small for filter length!\n");
    exit(-1);
  }

  int halflength=filterL/2;

  //signal beginning----------------------

  outputsignal[0]=0;
  for(int j=0;j<=halflength;++j)
    outputsignal[0]+=inputsignal[j];
  outputsignal[0]/=halflength+1;//average of the first halflength+1
  // input signal elements

  for(int i=1;i<=halflength+1;++i)
    outputsignal[i]=((i+halflength)*outputsignal[i-1]+inputsignal[i+halflength])
      /(i+halflength+1);

  //the whole middle
  for(int i=halflength+2;i<inputsignalL-halflength;++i)
    outputsignal[i]=((2*halflength+1)*outputsignal[i-1]+inputsignal[i+halflength]-inputsignal[i-halflength-1])/(2*halflength+1);


  //the final part of the signal
  for(int i=0;i<halflength;++i)
    outputsignal[inputsignalL-halflength+i]=
      ((2*halflength+1-i)*outputsignal[inputsignalL-halflength+i-1]
       -inputsignal[inputsignalL-2*halflength+i])/(2*halflength-i);
 
}					 
