#include<wfdb/wfdb.h>
#include<cstdio>
#include<vector>
using namespace std;


int giveintervalslimits(int intervalorder,vector<int>&intervals,int lengthsecs, 
			int samplingfreq,int*limits);//last is result


int selectannotationsonintervalstxt(char*rec,char*annotname,//rec includes signal num
				    vector<int>&intervals, int lengthsecs,
				    vector<vector<int> >&detectionsonintervals){

  char fname[30];
  strcpy(fname,rec);
  strcat(fname,annotname);
  FILE*fid=fopen(fname,"r");
  if(fid==NULL){
    printf("can not open file %s\n",fname);
    exit(-1);
  }

  int numannot;
  fscanf(fid,"%d",&numannot);

  int samplingfreq;
  fscanf(fid,"%d",&samplingfreq);


  if(numannot>0){

    int numintervals=intervals.size();
    int*limits=new int[2*numintervals];

    //detectionsonintervals.resize(numintervals);

    for(int i=0;i<numintervals;++i)
      giveintervalslimits(i,intervals, lengthsecs, samplingfreq, limits);

    int sample;

    fscanf(fid,"%d",&sample);

    for(int i=0;i<numintervals;++i){

      if(sample<limits[2*i])
	while((fscanf(fid,"%d",&sample)!=EOF)&&(sample<limits[2*i]))
	  ;
      
      detectionsonintervals[i].push_back(sample);
 
      while((fscanf(fid,"%d",&sample)!=EOF)&&(sample<limits[2*i+1]))
	detectionsonintervals[i].push_back(sample);
  
    }
    delete[] limits;
  }

  fclose(fid);
 

  return 0;
}



//read annotations (in wfdb format) from record x and select those that lie on given intervals
int selectannotationsonintervals(char*recpath,char*annotname,
				 vector<int>&intervals, int samplingfreq, int lengthsecs,
				 vector<vector<int> >&detectionsonintervals){

  int numintervals=intervals.size();
  int*limits=new int[2*numintervals];
  for(int i=0;i<numintervals;++i)
    giveintervalslimits(i, intervals, lengthsecs, samplingfreq, limits);

  WFDB_Anninfo an; 
  WFDB_Annotation annot;
  an.name = annotname;
  an.stat = WFDB_READ;

  if (annopen(recpath, &an, 2) < 0){
    printf("can not open annotation file %s for record %s!\n",annotname,recpath);
    exit(1);
  }

  for(int i=0;i<numintervals;++i){

    iannsettime(limits[2*i]);

    while ((getann(0, &annot) == 0)&&(annot.time <limits[2*i+1]))
      detectionsonintervals[i].push_back(annot.time);
  }

  wfdbquit();
  delete[] limits;

  return 0;
}



int giveintervalslimits(int  i,vector<int>&intervals,int lengthsecs, 
			int samplingfreq,int*limits){//last is result

  int interval=intervals[i];

  if(interval==0){//i must be zero

    limits[0]=0;
    limits[1]=2*lengthsecs*samplingfreq;
  }
  else{

    limits[2*i]=(interval+1)*lengthsecs*samplingfreq;
    limits[2*i+1]=(interval+2)*lengthsecs*samplingfreq;
  }

  return 0;
}
