#include<gsl/gsl_matrix.h>
#include <gsl/gsl_permutation.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_cblas.h>
#include<cassert>
#include<ctime>
#include <unistd.h>
#include <cstring>
#include<algorithm>
#include<cmath>
#include <sys/time.h>  
 #include <stdio.h>  
#include <wfdb/wfdb.h>
#include<vector>
using namespace std;

#include "auxfunctions.h"

int loadsignals(float**ptecg, float**ptbp, char*record, char*othersignal);

void createsignalqrs(vector<int>&annotations,float*signalqrs,
		     int samplingfreq, int numsamples, int numannot);

 

void findlocmax(gsl_vector_float*signal,vector<int>&locmax,float threshold,
		int radius);

/*int insertrecordall(char*recpath,char*nameannot, int samplingfreq,
		     char*signaltype, 
		     vector<float>&longsignal,vector<int>&longqrsannot);*/

int insertrecordall(char*recpath, int samplingfreq,
		    int sig, vector<float>&longsignal);

void movingaveragefilter(const float*inputsignal, float*outputsignal,
			 int filterL, int inputsignalL);


int main(int argc, char *argv[]){

  //argv[1]=recordpath
  //argv[2]=signal (0,1,...)
 
  /*int record=atoi(argv[1]);*/

  struct timeval begin, end;
  gettimeofday(&begin, NULL);

  int fs=100;//must be the same used  to learn the weights

  //int numsamplesrec=150000;//upperlimit
  //char signaltype[]="BP";

  vector<float> signal;
  vector<int> qrsannot;

  
  /*
 //record path
  char recstr[4];
  sprintf ( recstr, "%d", record);
  char basedir[]="/data/challenge2014data/set-p/";
  char fname[80];strcpy(fname,basedir);
  strcat(fname,recstr);
  */

  //char*nameannot="atr";

  int numsamples=insertrecordall(argv[1], fs,atoi(argv[2]), 
				 signal);

 
  printf("numsamples record is %d at %d samplingrate\n",numsamples,fs);

  ///--------------------------------old code ----------------

  
  // int numannot=qrsannot.size();
  // printf("num annotations is %d\n",numannot);
  // float *signalqrs=new float[numsamples];
  // createsignalqrs(qrsannot, signalqrs, fs, numsamples, numannot);

  //neuralnet
  int ninputs=300;
  int numhid=120;
  int noutputs=ninputs/2;

  gsl_matrix_float*w1=gsl_matrix_float_alloc(ninputs,numhid);
  gsl_matrix_float*w2=gsl_matrix_float_alloc(numhid,noutputs);
  gsl_vector_float*biases1=gsl_vector_float_alloc(numhid);
  gsl_vector_float*biases2=gsl_vector_float_alloc(noutputs);


  char biasandweights1hidfile[]="biasandweights1hidfile.txt";

  loadbiasesandweightsnnet1hid( biasandweights1hidfile, w1, w2,
				biases1, biases2);

  //gsl_vector_float_view qrsvector=gsl_vector_float_view_array(signalqrs,numsamples);
  gsl_vector_float_view inputsignal=
    gsl_vector_float_view_array(signal.data(),numsamples);



  gsl_vector_float*outputsignal=gsl_vector_float_alloc(numsamples);

  int batchsize=50;//100
  fwdnetinputsignal(&inputsignal.vector,w1, biases1, w2, biases2, outputsignal,
		    batchsize, ninputs, noutputs, noutputs/2, ninputs/2, noutputs);


  gsl_vector_float*filteredoutputsignal=gsl_vector_float_alloc(numsamples);

  int radius=150*fs/1000;//150 ms

  // movingaveragefilter(outputsignal->data, filteredoutputsignal->data,
  // 		      2*radius+1, numsamples);

  float threshold=0.3;//minimum value of output signal to detect qrs


  //now using outputsignal and not filteredoutputsignal--------------
  vector<int> qrslocations;
  findlocmax(outputsignal, qrslocations, threshold, radius);
  //-----------------------------------------------------------------

  FILE*fid=fopen("outputsignal.txt","w");
  for(int i=0;i<numsamples;++i)
    fprintf(fid,"%4.2f\n",gsl_vector_float_get (outputsignal,i));
  fclose(fid);

  // fid=fopen("filteredoutputsignal.txt","w");
  // for(int i=0;i<numsamples;++i)
  //   fprintf(fid,"%4.2f\n",gsl_vector_float_get (filteredoutputsignal,i));
  // fclose(fid);

  // fid=fopen("signalqrs.txt","w");
  // for(int i=0;i<numsamples;++i)
  //   fprintf(fid,"%4.2f\n",gsl_vector_float_get (&qrsvector.vector,i));
  // fclose(fid);


  fid=fopen("qrsannotations.txt","w");
  for(int i=0;i<(int) qrslocations.size();++i)
    fprintf(fid,"%d\n",qrslocations[i]);
  fclose(fid);

  fid=fopen("inputsignal.txt","w");
  for(int i=0;i<numsamples;++i)
    fprintf(fid,"%f\n",signal[i]);
  fclose(fid);

  gsl_matrix_float_free(w1);
  gsl_matrix_float_free(w2);
  gsl_vector_float_free(biases1);
  gsl_vector_float_free(biases2);

  gsl_vector_float_free(outputsignal);
  gsl_vector_float_free(filteredoutputsignal);

  //delete[] signalqrs;
  //delete[] signal;

  gettimeofday(&end, NULL);
  double t = (end.tv_sec - begin.tv_sec) +(double) (end.tv_usec - begin.tv_usec)/1000000;
                                                    
  printf("exec time %.6lf seconds\n",t);

  return 0;
}





